/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.biz.modular.consumptionrecord.service;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import jakarta.servlet.http.HttpServletResponse;
import vip.xiaonuo.biz.modular.consumptionrecord.entity.ConsumptionRecord;
import vip.xiaonuo.biz.modular.consumptionrecord.param.*;
import vip.xiaonuo.biz.modular.user.result.BizMemberUserResult;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 消费记录Service接口
 *
 * @author fanzherong
 * @date  2025/02/06 08:56
 **/
public interface ConsumptionRecordService extends IService<ConsumptionRecord> {

    /**
     * 获取消费记录分页
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     */
    Page<ConsumptionRecord> page(ConsumptionRecordPageParam consumptionRecordPageParam);

    Page<ConsumptionRecord> userPage(ConsumptionRecordPageParam consumptionRecordPageParam);

    /**
     * 添加消费记录
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     */
    void add(ConsumptionRecordAddParam consumptionRecordAddParam);

    /**
     * 编辑消费记录
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     */
    void edit(ConsumptionRecordEditParam consumptionRecordEditParam);

    /**
     * 删除消费记录
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     */
    void delete(List<ConsumptionRecordIdParam> consumptionRecordIdParamList);

    /**
     * 获取消费记录详情
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     */
    ConsumptionRecord detail(ConsumptionRecordIdParam consumptionRecordIdParam);

    /**
     * 获取消费记录详情
     *
     * @author fanzherong
     * @date  2025/02/06 08:56
     **/
    ConsumptionRecord queryEntity(String id);

    ConsumptionResult getRecordTotal();

    Map<String,Object> queryTodayRevenue(ConsumptionRecordPageParam consumptionRecordPageParam);

    ConsumptionResult getRecordTotal(ConsumptionRecordPageParam consumptionRecordPageParam);

    UserBalanceResult queryBalanceTotal(ConsumptionRecordPageParam consumptionRecordPageParam);

    Map<String,Object> queryConsumptionChart(ConsumptionRecordPageParam consumptionRecordPageParam);

    Map<String,Object> queryRechargeChar(ConsumptionRecordPageParam consumptionRecordPageParam);

    Map<String,Object> queryRechargeTotal(ConsumptionRecordPageParam consumptionRecordPageParam);

    Map<String,Object> queryEachStore(ConsumptionRecordPageParam consumptionRecordPageParam);

    Page<BizMemberUserResult> warnPage(ConsumptionRecordPageParam consumptionRecordPageParam);

    void exportRecord(ConsumptionRecordPageParam consumptionRecordPageParam, HttpServletResponse response) throws IOException;

}
